
#include "Arduino.h"
#include "pwmLight.h"

PwmLight::PwmLight(int pin, int changeSpeed) {
  _pin = pin; 
  _speed = changeSpeed;     // Higher speed value gives slower shange in brightness.
  pinMode(_pin, OUTPUT); 
  analogWrite(_pin, 0);
}
    
void PwmLight::setIntencity(int target) {   // Set the intencity of the light and update it. Call this function namy times per second. 

  if (_intencity < target) 
  {    
      _intencity += max((target - _intencity)/_speed, 1);            
  } 
  else if (_intencity > target) 
  {
      _intencity += min((0 - _intencity)/_speed, -1);            
  }
  
  analogWrite(_pin, _intencity);  
}
